
_main:
	MOV	#2048, W15
	MOV	#6142, W0
	MOV	WREG, 32
	MOV	#1, W0
	MOV	WREG, 52
	MOV	#4, W0
	IOR	68

;Pano_main.c,74 :: 		void main() {
;Pano_main.c,75 :: 		Start_TP();                 // Init the touchpanel
	CALL	_Start_TP
;Pano_main.c,76 :: 		showTitles();               // Show the title screen
	CALL	_showTitles
;Pano_main.c,77 :: 		while (1) {
L_main0:
;Pano_main.c,78 :: 		GetPanoTP();              // Read the touch panel and update the pano
	CALL	_getPanoTP
;Pano_main.c,79 :: 		frame_counter++;
	MOV	#1, W1
	MOV	#0, W2
	MOV	#lo_addr(_frame_counter), W0
	ADD	W1, [W0], [W0++]
	ADDC	W2, [W0], [W0--]
;Pano_main.c,80 :: 		}
	GOTO	L_main0
;Pano_main.c,81 :: 		}
L_end_main:
L__main_end_loop:
	BRA	L__main_end_loop
; end of _main

_showTitles:

;Pano_main.c,84 :: 		void showTitles(void){
;Pano_main.c,85 :: 		TFT_Set_Font(TFT_defaultFont, CL_WHITE, FO_HORIZONTAL);
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
	CLR	W13
	MOV	#65535, W12
	MOV	#lo_addr(_TFT_defaultFont), W10
	MOV	#___Lib_System_DefaultPage, W0
	MOV	W0, W11
	CALL	_TFT_Set_Font
;Pano_main.c,86 :: 		TFT_Write_Text("Mikromedia   Panorama   Viewer   V1.0", 48, 10);  // Write the string on the TFT Screen
	MOV	#10, W12
	MOV	#48, W11
	MOV	#lo_addr(?lstr1_Pano_main), W10
	CALL	_TFT_Write_Text
;Pano_main.c,87 :: 		TFT_Write_Text("by   Andrew   Hazelden", 90, 30);          // Write the string on the TFT Screen
	MOV	#30, W12
	MOV	#90, W11
	MOV	#lo_addr(?lstr2_Pano_main), W10
	CALL	_TFT_Write_Text
;Pano_main.c,88 :: 		TFT_EXT_Image(84, 63, icon_bmp, 1);                        // Draw the panorama icon
	MOV	#25988, W12
	MOV	#0, W13
	MOV	#63, W11
	MOV	#84, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Ext_Image
	SUB	#2, W15
;Pano_main.c,89 :: 		TFT_Write_Text("Tap   to   Continue...", 105, 210);        // Write the string on the TFT Screen
	MOV	#210, W12
	MOV	#105, W11
	MOV	#lo_addr(?lstr3_Pano_main), W10
	CALL	_TFT_Write_Text
;Pano_main.c,92 :: 		while (!TP_TFT_Press_Detect()) {
L_showTitles2:
	CALL	_TP_TFT_Press_Detect
	CP0.B	W0
	BRA Z	L__showTitles25
	GOTO	L_showTitles3
L__showTitles25:
;Pano_main.c,93 :: 		Delay_ms(50);
	MOV	#11, W8
	MOV	#11309, W7
L_showTitles4:
	DEC	W7
	BRA NZ	L_showTitles4
	DEC	W8
	BRA NZ	L_showTitles4
;Pano_main.c,94 :: 		}
	GOTO	L_showTitles2
L_showTitles3:
;Pano_main.c,97 :: 		TFT_Fill_Screen(CL_BLACK);
	CLR	W10
	CALL	_TFT_Fill_Screen
;Pano_main.c,98 :: 		}
L_end_showTitles:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	RETURN
; end of _showTitles

_getSlice:

;Pano_main.c,101 :: 		int getSlice(int n){
;Pano_main.c,102 :: 		if(n<0){
	CP	W10, #0
	BRA LT	L__getSlice27
	GOTO	L_getSlice6
L__getSlice27:
;Pano_main.c,104 :: 		n = n % (FRAME_RANGE);
	MOV	#960, W2
	REPEAT	#17
	DIV.S	W10, W2
	MOV	W1, W10
;Pano_main.c,106 :: 		n = (FRAME_RANGE) + n;
	MOV	#960, W0
	ADD	W0, W1, W0
	MOV	W0, W10
;Pano_main.c,107 :: 		}
L_getSlice6:
;Pano_main.c,109 :: 		n = n % (FRAME_RANGE);
	MOV	#960, W2
	REPEAT	#17
	DIV.S	W10, W2
	MOV	W1, W0
	MOV	W0, W10
;Pano_main.c,110 :: 		return n;
;Pano_main.c,111 :: 		}
L_end_getSlice:
	RETURN
; end of _getSlice

_getSlicePos:

;Pano_main.c,115 :: 		int getSlicePos(int x){
;Pano_main.c,116 :: 		return SLICE_WIDTH * x;
	SL	W10, #1, W0
;Pano_main.c,117 :: 		}
L_end_getSlicePos:
	RETURN
; end of _getSlicePos

_drawPano:
	LNK	#4

;Pano_main.c,120 :: 		void drawPano(int origin){
;Pano_main.c,121 :: 		int current_slice = 0;
	PUSH	W11
	PUSH	W12
	PUSH	W13
;Pano_main.c,122 :: 		int c=0;
;Pano_main.c,124 :: 		for(c=0;c<=VISIBLE_SLICES;c++){
; c start address is: 6 (W3)
	CLR	W3
; c end address is: 6 (W3)
L_drawPano7:
; c start address is: 6 (W3)
	MOV	#160, W0
	CP	W3, W0
	BRA LE	L__drawPano30
	GOTO	L_drawPano8
L__drawPano30:
;Pano_main.c,125 :: 		current_slice = getSlice(c+origin); // Calculate the active pano slices
	ADD	W3, W10, W0
	PUSH	W10
	MOV	W0, W10
	CALL	_getSlice
;Pano_main.c,126 :: 		TFT_EXT_Image(getSlicePos(c), 0, PANO_FRAMES[current_slice], 1);   //Draw the current slice
	SL	W0, #2, W1
	MOV	#lo_addr(_PANO_FRAMES), W0
	ADD	W0, W1, W2
	MOV.D	[W2], W0
	MOV	W0, [W14+0]
	MOV	W1, [W14+2]
	MOV	W3, W10
	CALL	_getSlicePos
	POP	W10
	MOV	[W14+0], W1
	MOV	[W14+2], W2
	PUSH	W3
	PUSH	W10
	MOV	W1, W12
	MOV	W2, W13
	CLR	W11
	MOV	W0, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Ext_Image
	SUB	#2, W15
	POP	W10
	POP	W3
;Pano_main.c,124 :: 		for(c=0;c<=VISIBLE_SLICES;c++){
	INC	W3
;Pano_main.c,132 :: 		}
; c end address is: 6 (W3)
	GOTO	L_drawPano7
L_drawPano8:
;Pano_main.c,139 :: 		}
L_end_drawPano:
	POP	W13
	POP	W12
	POP	W11
	ULNK
	RETURN
; end of _drawPano

_writeInt:
	LNK	#8

;Pano_main.c,144 :: 		void writeInt(int n, unsigned int x, unsigned int y){
;Pano_main.c,146 :: 		IntToStr(n, txt);           // Convert the int to a text string
	PUSH	W10
	ADD	W14, #0, W0
	PUSH	W11
	MOV	W0, W11
	CALL	_IntToStr
	POP	W11
;Pano_main.c,147 :: 		TFT_Write_Text(txt, x, y);  // Write the int on the TFT Screen
	ADD	W14, #0, W0
	MOV	W0, W10
	CALL	_TFT_Write_Text
;Pano_main.c,148 :: 		}
L_end_writeInt:
	POP	W10
	ULNK
	RETURN
; end of _writeInt

_writeLabeledInt:
	LNK	#118

;Pano_main.c,151 :: 		void writeLabeledInt(char *label, int n, unsigned int x, unsigned int y){
;Pano_main.c,154 :: 		IntToStr(n, txt);           // Convert the int to a text string
	PUSH	W10
	PUSH	W11
	PUSH	W12
	ADD	W14, #0, W0
	PUSH	W10
	MOV	W11, W10
	MOV	W0, W11
	CALL	_IntToStr
	POP	W10
;Pano_main.c,155 :: 		strncpy(output_text, label, 100);  // Add the label to the output_text string
	ADD	W14, #7, W0
	PUSH	W12
	MOV	#100, W12
	MOV	W10, W11
	MOV	W0, W10
	CALL	_strncpy
;Pano_main.c,156 :: 		strncat(output_text, txt, 7);   // Add the number string to the output_text string
	ADD	W14, #0, W1
	ADD	W14, #7, W0
	MOV	#7, W12
	MOV	W1, W11
	MOV	W0, W10
	CALL	_strncat
	POP	W12
;Pano_main.c,157 :: 		TFT_Write_Text(output_text, x, y);  // Write the string on the TFT Screen
	ADD	W14, #7, W0
	MOV	W12, W11
	MOV	W13, W12
	MOV	W0, W10
	CALL	_TFT_Write_Text
;Pano_main.c,158 :: 		}
L_end_writeLabeledInt:
	POP	W12
	POP	W11
	POP	W10
	ULNK
	RETURN
; end of _writeLabeledInt

_writeLabeledInt2:
	LNK	#118

;Pano_main.c,161 :: 		void writeLabeledInt2(char *label1, int n, char *label2, unsigned int x, unsigned int y){
;Pano_main.c,164 :: 		IntToStr(n, txt);                   // Convert the int to a text string
	PUSH	W10
	PUSH	W11
	PUSH	W12
; y start address is: 10 (W5)
	MOV	[W14-8], W5
	ADD	W14, #0, W0
	PUSH	W10
	MOV	W11, W10
	MOV	W0, W11
	CALL	_IntToStr
	POP	W10
;Pano_main.c,165 :: 		strncpy(output_text, label1, 50);   // Add the 1st label to the output_text string
	ADD	W14, #7, W0
	PUSH	W12
	MOV	#50, W12
	MOV	W10, W11
	MOV	W0, W10
	CALL	_strncpy
;Pano_main.c,166 :: 		strncat(output_text, txt, 7);       // Add the number string to the output_text string
	ADD	W14, #0, W1
	ADD	W14, #7, W0
	MOV	#7, W12
	MOV	W1, W11
	MOV	W0, W10
	CALL	_strncat
	POP	W12
;Pano_main.c,167 :: 		strncat(output_text, label2, 50);   // Add the 2nd label to the output_text string
	ADD	W14, #7, W0
	MOV	W12, W11
	MOV	#50, W12
	MOV	W0, W10
	CALL	_strncat
;Pano_main.c,168 :: 		TFT_Write_Text(output_text, x, y);  // Write the string on the TFT Screen
	ADD	W14, #7, W0
	MOV	W5, W12
; y end address is: 10 (W5)
	MOV	W13, W11
	MOV	W0, W10
	CALL	_TFT_Write_Text
;Pano_main.c,169 :: 		}
L_end_writeLabeledInt2:
	POP	W12
	POP	W11
	POP	W10
	ULNK
	RETURN
; end of _writeLabeledInt2

_getPanoTP:
	LNK	#4

;Pano_main.c,174 :: 		void getPanoTP() {
;Pano_main.c,180 :: 		float view_degrees = 0;                  // View angle in degrees
	PUSH	W10
	PUSH	W11
;Pano_main.c,190 :: 		pano_view = pano_view % FRAME_RANGE;
	MOV	getPanoTP_pano_view_L0, W0
	MOV	#960, W2
	REPEAT	#17
	DIV.S	W0, W2
	MOV	W1, W0
	MOV	W0, getPanoTP_pano_view_L0
;Pano_main.c,213 :: 		if (TP_TFT_Press_Detect()) {
	CALL	_TP_TFT_Press_Detect
	CP0.B	W0
	BRA NZ	L__getPanoTP35
	GOTO	L_getPanoTP10
L__getPanoTP35:
;Pano_main.c,215 :: 		if (TP_TFT_Get_Coordinates(&x_coord, &y_coord) == 0) {
	MOV	#lo_addr(getPanoTP_y_coord_L0), W11
	MOV	#lo_addr(getPanoTP_x_coord_L0), W10
	CALL	_TP_TFT_Get_Coordinates
	CP.B	W0, #0
	BRA Z	L__getPanoTP36
	GOTO	L_getPanoTP11
L__getPanoTP36:
;Pano_main.c,217 :: 		if (PenDown == 0) {
	MOV	getPanoTP_PenDown_L0, W0
	CP	W0, #0
	BRA Z	L__getPanoTP37
	GOTO	L_getPanoTP12
L__getPanoTP37:
;Pano_main.c,219 :: 		PenDown = 1;
	MOV	#1, W0
	MOV	W0, getPanoTP_PenDown_L0
;Pano_main.c,225 :: 		prev_x_coord = x_coord;
	MOV	getPanoTP_x_coord_L0, W0
	MOV	W0, getPanoTP_prev_x_coord_L0
;Pano_main.c,229 :: 		drag_x_distance = 0;
	CLR	W0
	MOV	W0, getPanoTP_drag_x_distance_L0
;Pano_main.c,231 :: 		}
L_getPanoTP12:
;Pano_main.c,235 :: 		drag_x_distance = (x_coord - prev_x_coord); // Calculate how far the TP drag event was
	MOV	getPanoTP_x_coord_L0, W2
	MOV	#lo_addr(getPanoTP_prev_x_coord_L0), W1
	MOV	#lo_addr(getPanoTP_drag_x_distance_L0), W0
	SUB	W2, [W1], [W0]
;Pano_main.c,239 :: 		if(x_coord != prev_x_coord){
	MOV	getPanoTP_x_coord_L0, W1
	MOV	#lo_addr(getPanoTP_prev_x_coord_L0), W0
	CP	W1, [W0]
	BRA NZ	L__getPanoTP38
	GOTO	L_getPanoTP13
L__getPanoTP38:
;Pano_main.c,241 :: 		drawPano(pano_view - (drag_x_distance/SLICE_WIDTH) );  // Draw the pano from the starting TP point
	MOV	getPanoTP_drag_x_distance_L0, W0
	ASR	W0, #1, W1
	MOV	#lo_addr(getPanoTP_pano_view_L0), W0
	SUBR	W1, [W0], W0
	MOV	W0, W10
	CALL	_drawPano
;Pano_main.c,242 :: 		}
L_getPanoTP13:
;Pano_main.c,243 :: 		}
L_getPanoTP11:
;Pano_main.c,244 :: 		}
	GOTO	L_getPanoTP14
L_getPanoTP10:
;Pano_main.c,245 :: 		else if (PenDown == 1) {
	MOV	getPanoTP_PenDown_L0, W0
	CP	W0, #1
	BRA Z	L__getPanoTP39
	GOTO	L_getPanoTP15
L__getPanoTP39:
;Pano_main.c,247 :: 		PenDown = 0;
	CLR	W0
	MOV	W0, getPanoTP_PenDown_L0
;Pano_main.c,250 :: 		pano_view -= (drag_x_distance/SLICE_WIDTH);
	MOV	getPanoTP_drag_x_distance_L0, W0
	ASR	W0, #1, W1
	MOV	#lo_addr(getPanoTP_pano_view_L0), W0
	SUBR	W1, [W0], [W0]
;Pano_main.c,253 :: 		if(drag_x_distance>0){
	MOV	getPanoTP_drag_x_distance_L0, W0
	CP	W0, #0
	BRA GT	L__getPanoTP40
	GOTO	L_getPanoTP16
L__getPanoTP40:
;Pano_main.c,255 :: 		}
	GOTO	L_getPanoTP17
L_getPanoTP16:
;Pano_main.c,258 :: 		}
L_getPanoTP17:
;Pano_main.c,267 :: 		drag_x_distance = 0;
	CLR	W0
	MOV	W0, getPanoTP_drag_x_distance_L0
;Pano_main.c,270 :: 		x_coord = 0;
	CLR	W0
	MOV	W0, getPanoTP_x_coord_L0
;Pano_main.c,271 :: 		y_coord = 0;
	CLR	W0
	MOV	W0, getPanoTP_y_coord_L0
;Pano_main.c,273 :: 		prev_x_coord = 0;
	CLR	W0
	MOV	W0, getPanoTP_prev_x_coord_L0
;Pano_main.c,277 :: 		}
L_getPanoTP15:
L_getPanoTP14:
;Pano_main.c,281 :: 		view_degrees = 360 - ( ((float) pano_view / (float) FRAME_RANGE) * 360);
	MOV	getPanoTP_pano_view_L0, W0
	ASR	W0, #15, W1
	SETM	W2
	CALL	__Long2Float
	MOV	#0, W2
	MOV	#17520, W3
	CALL	__Div_FP
	MOV	#0, W2
	MOV	#17332, W3
	CALL	__Mul_FP
	MOV	W0, [W14+0]
	MOV	W1, [W14+2]
	MOV	#0, W0
	MOV	#17332, W1
	PUSH.D	W2
	MOV	[W14+0], W2
	MOV	[W14+2], W3
	CALL	__Sub_FP
	POP.D	W2
;Pano_main.c,282 :: 		if(view_degrees<0){
	CLR	W2
	CLR	W3
	CALL	__Compare_Le_Fp
	CP0	W0
	CLR.B	W0
	BRA GE	L__getPanoTP41
	INC.B	W0
L__getPanoTP41:
	CP0.B	W0
	BRA NZ	L__getPanoTP42
	GOTO	L_getPanoTP18
L__getPanoTP42:
;Pano_main.c,284 :: 		}
L_getPanoTP18:
;Pano_main.c,287 :: 		if( prev_pano_view != pano_view ){
	MOV	getPanoTP_prev_pano_view_L0, W1
	MOV	#lo_addr(getPanoTP_pano_view_L0), W0
	CP	W1, [W0]
	BRA NZ	L__getPanoTP43
	GOTO	L_getPanoTP19
L__getPanoTP43:
;Pano_main.c,290 :: 		if(pendown){
	MOV	#lo_addr(getPanoTP_PenDown_L0), W0
	CP0	[W0]
	BRA NZ	L__getPanoTP44
	GOTO	L_getPanoTP20
L__getPanoTP44:
;Pano_main.c,291 :: 		drawPano(pano_view - (drag_x_distance/SLICE_WIDTH) );
	MOV	getPanoTP_drag_x_distance_L0, W0
	ASR	W0, #1, W1
	MOV	#lo_addr(getPanoTP_pano_view_L0), W0
	SUBR	W1, [W0], W0
	MOV	W0, W10
	CALL	_drawPano
;Pano_main.c,292 :: 		}
	GOTO	L_getPanoTP21
L_getPanoTP20:
;Pano_main.c,294 :: 		drawPano(pano_view);           // Draw the pano from the starting TP point
	MOV	getPanoTP_pano_view_L0, W10
	CALL	_drawPano
;Pano_main.c,295 :: 		}
L_getPanoTP21:
;Pano_main.c,326 :: 		}
L_getPanoTP19:
;Pano_main.c,328 :: 		prev_pano_view = pano_view;           // Save the last pano view position
	MOV	getPanoTP_pano_view_L0, W0
	MOV	W0, getPanoTP_prev_pano_view_L0
;Pano_main.c,330 :: 		}
L_end_getPanoTP:
	POP	W11
	POP	W10
	ULNK
	RETURN
; end of _getPanoTP
